<?php

namespace Drupal\dsfr_core;

use Drupal\Core\Controller\ControllerBase;

class FieldStorage extends ControllerBase {

  /**
   * {@inheritdoc}
   */
  public function margin() {

    return [
      '0-5v' => '0,5v (2px)',
      '1v' => '1v (4px)',
      '1-5v' => '1,5v (6px)',
      '1w' => '1w (8px)',
      '3v' => '3v (12px)',
      '2w' => '2w (16px)',
      '5v' => '5v (20px)',
      '3w' => '3w (24px)',
      '4w' => '4W (32px)',
      '5w' => '5w (40px)',
      '6w' => '6w (48px)',
      '7w' => '7w (56px)',
      '8w' => '8w (64px)',
      '9w' => '9w (72px)',
      '12w' => '12w (96px)',
      '15w' => '15w (120px)',
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function colors() {

    return [
      'green-tilleul-verveine' => $this->t('Green Tilleul Verveine'),
      'green-bourgeon' => $this->t('Green Bourgeon'),
      'green-emeraude' => $this->t('Green Emeraude'),
      'green-menthe' => $this->t('Green Menthe'),
      'green-archipel' => $this->t('Green Archipel'),
      'blue-ecume' => $this->t('Blue Ecume'),
      'blue-cumulus' => $this->t('Blue Cumulus'),
      'purple-glycine' => $this->t('Purple Glycine'),
      'pink-macaron' => $this->t('Pink Macaron'),
      'pink-tuile' => $this->t('Pink Tuile'),
      'yellow-tournesol' => $this->t('Yellow Tournesol'),
      'yellow-moutarde' => $this->t('Yellow Moutarde'),
      'orange-terre-battue' => $this->t('Orange Terre Battue'),
      'brown-cafe-creme' => $this->t('Brown Cafe Creme'),
      'brown-caramel' => $this->t('Brown Caramel'),
      'brown-opera' => $this->t('Brown Opera'),
      'beige-gris-galet' => $this->t('Beige Gris Galet'),
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function fieldData() {

    return [

      'body' => [ 'type' => 'text_with_summary' ],

      'field_action' => ['type' => 'link', 'module' => 'link' ],

      'field_alert' => [
        'type' => 'list_string',
        'module' => 'options',
        'settings' => [
          'allowed_values' => [
            'info' => $this->t('Information'),
            'success' => $this->t('Success'),
            'warning' => $this->t('Warning'),
            'error' => $this->t('Error'),
          ]
        ],
      ],

      'field_close' => [ 'type' => 'boolean' ],

      'field_color' => [
        'type' => 'list_string',
        'module' => 'options',
        'settings' => [
          'allowed_values' => $this->colors(),
        ],
      ],

      'field_compact' => [ 'type' => 'boolean' ],
      
      //'dsfr_restricted_html' => [],

      'field_font_size' => [
        'type' => 'list_string',
        'module' => 'options',
        'settings' => [
          'allowed_values' => [
            '1' => $this->t('Small'),
            '2' => $this->t('By default'),
            '3' => $this->t('Large')
          ]
        ],
      ],

      'field_hidden' => [ 'type' => 'boolean' ],

      'field_icon' => [
        'type' => 'list_string',
        'module' => 'options',
        'settings' => [
          'allowed_values' => [
            'l' => $this->t('Left'),
            'r' => $this->t('Right)'
          ]
        ],
      ],

      // 'image' => [],

      'field_margin_bottom' => [
        'type' => 'list_string',
        'module' => 'options',
        'settings' => [
          'allowed_values' => $this->margin(),
        ],
      ],

      'field_margin_top' => [
        'type' => 'list_string',
        'module' => 'options',
        'settings' => [
          'allowed_values' => $this->margin(),
        ],
      ],

      'field_position' => [
        'type' => 'list_string',
        'module' => 'options',
        'settings' => [
          'allowed_values' => [
            'l' => $this->t('Left'),
            'c' => $this->t('Center'),
            'r' => $this->t('Right')
          ]
        ]
      ]
    ];
  }
}